<script>
import { GlAvatarLink, GlAvatar, GlBadge, GlCard } from "@gitlab/ui";
import ImageComponent from "./ImageComponent.vue";
import VideoComponent from "./VideoComponent.vue";

export default {
  components: {
    GlAvatarLink,
    GlAvatar,
    GlBadge,
    GlCard,
    ImageComponent,
    VideoComponent,
  },
  props: {
    papercut: Object,
  },
  labels: [
    {
      title: "UI polish",
      class: "info",
    },
    {
      title: "Beautifying our UI",
      class: "success",
    },
    {
      title: "UX Paper Cuts",
      class: "tier",
    },
  ],
  methods: {
    labelClass(label) {
      return this.$options.labels.find((l) => l.title === label).class;
    },
    userProfile(username) {
      return `https://gitlab.com/${username}`;
    },
  },
};
</script>
<template>
  <gl-card
    class="gl-mb-5"
    header-class="gl-flex gl-flex-wrap gl-items-center gl-justify-between gl-gap-2 gl-w-full"
    body-class="gl-p-0"
  >
    <template #header>
      <div class="gl-inline-flex gl-items-center gl-flex-wrap gl-gap-2">
        <a :href="papercut.url" target="blank" class="gl-link">
          {{ papercut.title }}</a
        >
        <div class="gl-flex gl-items-center gl-gap-2">
          by
          <gl-avatar-link
            :href="userProfile(papercut.username)"
            target="_blank"
          >
            <gl-avatar :size="24" :src="papercut.avatarUrl" /><span
              class="gl-ml-2"
              >@{{ papercut.username }}</span
            >
          </gl-avatar-link>
        </div>
      </div>
      <div class="gl-inline-flex gl-flex-wrap gl-gap-2" v-if="papercut.labels">
        <gl-badge
          v-for="label in papercut.labels"
          :key="label.title"
          :variant="labelClass(label)"
          size="md"
        >
          {{ label }}
        </gl-badge>
      </div>
    </template>

    <table class="gl-table gl-w-full">
      <tr>
        <th>Before</th>
        <th>After</th>
      </tr>
      <tr v-for="image in papercut.images" :key="image.mergeRequestId">
        <td class="gl-w-1/2">
          <ImageComponent
            v-if="image.before?.type === 'img'"
            :src="image.before.src"
          />
          <VideoComponent
            v-else-if="image.before?.type === 'video'"
            :src="image.before.src"
          />
          <span v-else class="gl-italic gl-text-subtle">(None)</span>
        </td>
        <td class="gl-w-1/2">
          <ImageComponent
            v-if="image.after?.type === 'img'"
            :src="image.after.src"
          />
          <VideoComponent
            v-else-if="image.after?.type === 'video'"
            :src="image.after.src"
          />
          <span v-else class="gl-italic gl-text-subtle">(None)</span>
        </td>
      </tr>
    </table>
  </gl-card>
</template>
